﻿jQuery.fn.sn_gallery = function ($targets) {
    var $ = jQuery;

    /*メンバ変数*/
    var $elements = this;
    var DELAY = 200;
    var timer;
    var locations = {};

    console.log($targets);
    if (typeof $targets === 'undefined') $targets = [];

    /*メンバメソッド*/
    var initialize = function ($element) {
        var uniqueClass = 'gallery-' + (Math.floor(Math.random() * 1000000000000).toString().replace(/(\d{4})(\d{4})(\d{4})/, '$1-$2-$3'));
        $element.attr('data-class', uniqueClass);
        $img = $element.children('img');
        $location = $('<ul />', { 'class': 'location', id: uniqueClass });
        $img.each(function (num) {

            var index = ('00' + num).slice(-3);
            var htmlClassName = 'c-' + index;
            $element.append($(this).addClass(htmlClassName));
            $location.append($('<li />', { 'class': 'location-icon ' + htmlClassName, 'data-class': htmlClassName, 'data-index': num }));
        });
        $location
            .append($('<li />', { 'class': 'location-btn next', 'attr-action': 'next' }))
            .append($('<li />', { 'class': 'location-btn prev', 'attr-action': 'prev' }));

        $element.after($location).addClass(uniqueClass);
    };

    var setLocationIcons = function ($element) {
        var _locations = {};
        var locationZero = undefined;
        var targetClass = $element.attr('data-class');
        var scrollWidth = $element.get(0).scrollWidth;
        var scrollLeft = $element.scrollLeft();
        var clientWidth = $element.prop('clientWidth');

        var $img = $element.children('img');
        if ($img.length === 0) {
            locations[targetClass] = _locations;
            return;
        }
        $img.each(function (index) {
            var $this = $(this);
            var index = ('00' + index).slice(-3);
            var id = 'c-' + index;
            var $locationIcon = $('#' + targetClass + ' .' + id);

            var position = $this.position();
            var outerWidth = $this.outerWidth();
            var left = position.left;
            var right = left + outerWidth;

            if (typeof locationZero === 'undefined') locationZero = left * -1;
            _locations[id] = { left: left + locationZero, right: right + locationZero };

            var insideCheck = (left >= 0 && right <= clientWidth);
            var halfInsideCheck = ((left < 0 && right >= 0) || (left >= 0 && left <= clientWidth && right > clientWidth));

            if (insideCheck) $locationIcon.removeClass('half-inside').addClass('inside');
            else if (halfInsideCheck) $locationIcon.removeClass('inside').addClass('half-inside');
            else $locationIcon.removeClass('inside half-inside');
        });
        locations[targetClass] = _locations;
    };

    var scrollAdjust = function ($element) {
        var targetClass = $element.attr('data-class');
        var scrollWidth = $element.get(0).scrollWidth;
        var scrollLeft = $element.scrollLeft();
        var clientWidth = $element.prop('clientWidth');
        var scrollLeftTaregt = 0;

        var $halfInside = $('#' + targetClass + ' .half-inside');
        var $inside = $('#' + targetClass + ' .inside');

        if ($inside.length > 0) {
            var id = $inside.eq(0).attr('data-class');
            scrollLeftTaregt = locations[targetClass][id].left;
        } else if ($halfInside.length > 0) {
            var id = $halfInside.eq(0).attr('data-class');
            scrollLeftTaregt = locations[targetClass][id].left;
        }

        if (typeof scrollLeftTaregt === 'undefined') scrollLeftTaregt = 0;
        $element.animate({ scrollLeft: scrollLeftTaregt }, { duration: 200, easing: 'swing', complete: function () { } });
    };

    $elements
        .addClass('image-slider')
        .each(function () {
            var $element = $(this);
            initialize($element);
            $element.scrollLeft(0);
            setLocationIcons($element);
            var $images = $('img', $element);
            var imageCount = $images.length;
            var completeCount = 0;
            $images.on('load', function () {
                if (imageCount === ++completeCount) {
                    setLocationIcons($element);
                    scrollAdjust($element);
                }
            });
        })
        .on('scroll', function () {
            var $element = $(this);
            setLocationIcons($element);
            if (timer) clearTimeout(timer);
            timer = setTimeout(function () {
                scrollAdjust($element);
            }, DELAY);
        });
    $targets.each(function () {
        var $this = $(this);
        $this.on('click.gallery', function () {
            $elements.each(function () {
                var $element = $(this);
                setLocationIcons($element);
                scrollAdjust($element);
            });
            $this.off('click.gallery');
        });
    });

    $(document)
        .on('click', 'ul.location li.location-icon', function () {
            var $element = $(this);
            var parent = $element.parent();
            var id = $element.attr('data-class');
            var targetID = parent.attr('id');
            var scrollLeftTaregt = locations[targetID][id].left;
            var $gallery = $('.gallery.' + targetID);
            $gallery.animate({ scrollLeft: scrollLeftTaregt }, { duration: 200, easing: 'swing', complete: function () { } });
        })
        .on('click', 'ul.location li.location-btn', function () {
            var $element = $(this);
            var parent = $element.parent();
            var action = $element.attr('attr-action');
            var targetID = parent.attr('id');

            var images = $('.' + targetID + ' img');
            var currentImg = $('#' + targetID + ' .inside:first');
            if (currentImg.length === 0) currentImg = $('.' + targetID + ' .half-inside:first');

            var index = parseFloat(currentImg.attr('data-index'));

            if (action === 'next') index--;
            else if (action === 'prev') index++;

            if (index < 0) index = 0;
            if (index >= images.length) index = images.length - 1;

            index = ('00' + index).slice(-3);
            var id = 'c-' + index;

            var scrollLeftTaregt = locations[targetID][id].left;

            var $gallery = $('.gallery.' + targetID);
            $gallery.animate({ scrollLeft: scrollLeftTaregt }, { duration: 200, easing: 'swing', complete: function () { } });
        });

    $(window)
        .on('orientationchange resize', function () {
            $elements.each(function () {
                var $element = $(this);
                setLocationIcons($element);
                scrollAdjust($element);
            });
        });
    return this;
};
